#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

void Init_Clock()
{
	MCGC2 = MCGC2_HGO_MASK		// HighQC[h
		| MCGC2_EREFS_MASK	// Og
		| MCGC2_RANGE_MASK	// 1-16MHz̊Ԃɂ
		| MCGC2_ERCLKEN_MASK;	// Ot@Xg
	while (MCGSC_OSCINIT == 0)
		;

	MCGC1 = (2<<6)			// CLKS = 10: external reference clock.
		| (3<<3);		// RDIV = 3 : 12MHz/8=1.5 MHz

	while ((MCGSC_IREFST != 0) || (MCGSC_CLKST != 2))

	// FBE [h PBE (PLL bypassed internal) [hɈڍs
	MCGC3=MCGC3_PLLS_MASK
		| (8<<0);		// VDIV=6 -> multiply by 32 -> 1.5MHz * 32 = 48MHz
	while((MCGSC_PLLST != 1) || (MCGSC_LOCK != 1))
		;
	// PBE[hPEE (PLL enabled external mode)[hɈڍs
	MCGC1 = (0<<6)			// CLKS = 0 -> PLL or FLL output clock.
		| (3<<3);		// RDIV = 3 -> 12MHz/8=1.5 MHz
	while(MCGSC_CLKST !=3)
		;
}

void Init_Port()
{
//@PTA͖gpiƂ肠SsvAbvj
	PTAD  = 0x00;
	PTADD = 0x00;
	PTAPE = 0xff;
	PTASE = 0x00;
	PTADS = 0x00;

// PB[0]FLED
// PB[1]FResetSwitch
// PB[2]FBKGD
// PB[3]FBLMSXCb`
// PB[4]FXTAL(12MHzj
// PB[5]=>XTAL(12MHzj
// PB[6]=> N/A
// PB[7]=> N/A
	PTBD  = 0x01;
	PTBDD = 0x01;
	PTBPE = 0x0e;
	PTBSE = 0x00;
	PTBDS = 0x00;
}

void main(void) {
  unsigned int i,j,k;
  unsigned char c;
  EnableInterrupts; /* enable interrupts */

	SOPT1 = 0x11;	// WDT~DPB1Zbg͂ƂĎg
	Init_Clock();	// NbN[hݒiO12MHzCPLLgpCCPU:48MHzCoXNbNF24MHzj
	Init_Port();	// PTA,PTB̏
 	c = 0;
	for(k=0;k<20;k++) {
		for (i=0; i<10; i++) {
			for (j=0; j<10000; j++) {
//				__RESET_WATCHDOG();
			}
		}
		if (c & 1) {
			PTBD |= 0x01;
		} else {
			PTBD &= ~0x01;
		}
		c++;
	}
	for(;;)
	;
}
